unit Formstar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Driver, Global, Menus, ExtCtrls;

type
  Tfrmstart = class(TForm)
    cmdRun: TButton;
    labIOAddr: TLabel;
    cmdExit: TButton;
    HScroll1: TScrollBar;
    tmrWrite: TTimer;
    GroupBox1: TGroupBox;
    myStatus: TMemo;
    Refresh: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure cmdExitClick(Sender: TObject);
    procedure cmdRunClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RefreshClick(Sender: TObject);
    procedure tmrWriteTimer(Sender: TObject);
    procedure HScroll1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmstart: Tfrmstart;

implementation

var
   lpDevFeatures      : DEVFEATURES;
   gnNumOfSubdevices  : Smallint;
   Response           : Integer;

{$R *.DFM}
procedure Tfrmstart.cmdExitClick(Sender: TObject);
begin
     tmrWrite.Enabled := False;
     close;
end;

procedure Tfrmstart.cmdRunClick(Sender: TObject);
begin
     If (Status = False) Then
     begin
        Status := True;
        cmdRun.Caption := '&Stop';
        myStatus.Text := 'Start to write Watchdog timer (Hex 443h)';
        tmrWrite.Enabled := True;
     end
     else
     begin
        Status := False;
        cmdRun.Caption := '&Start';
        myStatus.Text := 'Stop writing Watchdog timer (Hex 443h)';
        tmrWrite.Enabled := False;
     end;
end;

procedure Tfrmstart.FormCreate(Sender: TObject);
begin
  tmrWrite.Interval := 20;
  tmrWrite.Enabled  := False;
  Status            := False;
  ErrCount          := 0;
  HEX43             := $43;
  HEX443            := $443;
end;


procedure Tfrmstart.RefreshClick(Sender: TObject);
var
     WordData : Word;
begin
     ErrCde := DRV_inp(0, HEX43, WordData);
     If (ErrCde <> 0) Then
     begin
          DRV_GetErrorMessage(ErrCde, pszErrMsg);
          Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
          Exit;
     end;
     myStatus.Text := 'Refresh the Watchdog timer!';
end;

procedure Tfrmstart.tmrWriteTimer(Sender: TObject);
begin
     ErrCde := DRV_outp(1, HEX443, DataValue);
     If (ErrCde <> 0) Then
     begin
          DRV_GetErrorMessage(ErrCde, pszErrMsg);
          Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
          Exit;
     end;
     myStatus.Text := 'Refresh the Watchdog timer!';
end;

procedure Tfrmstart.HScroll1Change(Sender: TObject);
begin
     tmrWrite.Interval := HScroll1.Position;
     DataValue := HScroll1.Position;
end;



end.
